diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java b/src/main/java/net/minecraft/client/render/item/model/LabelItemModel.java
similarity index 72%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
rename to src/main/java/net/minecraft/client/render/item/model/LabelItemModel.java
index 6d0bfc378..4a68592b6 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/LabelItemModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemModelLabel extends ItemModelStandard{
+public class LabelItemModel extends StandardItemModel {
     protected IconCoordinate writtenLabel = TextureRegistry.getTexture("minecraft:item/label_written");
-    public ItemModelLabel(Item item, String namespace) {
+    public LabelItemModel(Item item, String namespace) {
         super(item, namespace);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/src/main/java/net/minecraft/client/render/item/model/MapItemModel.java
similarity index 78%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
rename to src/main/java/net/minecraft/client/render/item/model/MapItemModel.java
index 810d2da78..b2b99f46b 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/src/main/java/net/minecraft/client/render/item/model/MapItemModel.java
@@ -9,27 +9,34 @@ import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.entity.PlayerRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.MapItem;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
-public class ItemModelMap extends ItemModelStandard {
+public class MapItemModel extends StandardItemModel {
     private final Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
     private final MapItemRenderer renderMapInstance = new MapItemRenderer(mc.fontRenderer, mc.gameSettings, mc.renderEngine);
 
-    public ItemModelMap(Item item, String namespace) {
+    public MapItemModel(Item item, String namespace) {
         super(item, namespace);
     }
 
     @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
-    	int blockX = MathHelper.floor_double(player.x);
-    	int blockY = MathHelper.floor_double(player.y);
-    	int blockZ = MathHelper.floor_double(player.z);
+    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
+    	int blockX = MathHelper.floor(player.x);
+    	int blockY = MathHelper.floor(player.y);
+    	int blockZ = MathHelper.floor(player.z);
     	
         // Apply appropriate brightness
         float brightness = 1.0f;
@@ -54,10 +61,10 @@ public class ItemModelMap extends ItemModelStandard {
         GL11.glTranslatef(0.0F, (-(1.0F - renderer.getEquippedProgress(partialTick)) * 1.2F - f_val * 0.5F) + 0.04F, zOff); // Place map at right distance from camera
         GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(f_val * -85F, 0.0F, 0.0F, 1.0F);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
         // Render both player arms
-        mc.renderEngine.loadDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+        mc.renderEngine.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
         PlayerRenderer playerRenderer = (PlayerRenderer) (EntityRenderer<? extends Entity>) EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
 
         GL11.glPushMatrix();
@@ -95,7 +102,7 @@ public class ItemModelMap extends ItemModelStandard {
         GL11.glNormal3f(0.0F, 0.0F, -1F);
 
         // Render paper background of map
-        mc.renderEngine.bindTexture(mc.renderEngine.getTexture("/misc/mapbg.png"));
+        mc.renderEngine.bindTexture(mc.renderEngine.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
         tessellator.startDrawingQuads();
         final byte expansion = 7; // makes the edges extend around the actual map data by a bit
         tessellator.addVertexWithUV(-expansion,     128 + expansion, 0.0D, 0.0D, 1.0D);
@@ -104,7 +111,15 @@ public class ItemModelMap extends ItemModelStandard {
         tessellator.addVertexWithUV(-expansion,     -expansion,      0.0D, 0.0D, 0.0D);
         tessellator.draw();
 
-        ItemMapSavedData mapData = Item.map.getOrCreateSavedData(stack, mc.theWorld);
+        ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(stack, mc.theWorld);
+        if (mapData == null) return;
         renderMapInstance.renderMap(mc.renderEngine, mapData, brightness);
     }
+    @Override
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
+        if (!MapItem.hasInitialized(itemStack)){
+            return TextureRegistry.getTexture("minecraft:item/map_blank");
+        }
+        return super.getIcon(entity, itemStack);
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java b/src/main/java/net/minecraft/client/render/item/model/QuiverItemModel.java
similarity index 73%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
rename to src/main/java/net/minecraft/client/render/item/model/QuiverItemModel.java
index 78b1418d1..6567638d5 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
+++ b/src/main/java/net/minecraft/client/render/item/model/QuiverItemModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemModelQuiver extends ItemModelStandard{
+public class QuiverItemModel extends StandardItemModel {
     protected IconCoordinate quiverFull = TextureRegistry.getTexture("minecraft:item/armor_quiver_empty");
-    public ItemModelQuiver(Item item, String namespace) {
+    public QuiverItemModel(Item item, String namespace) {
         super(item, namespace);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
rename to src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
index b14ac8af0..56d46e723 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
@@ -6,17 +6,18 @@ import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 import java.awt.*;
 import java.util.Random;
@@ -37,7 +38,7 @@ import static org.lwjgl.opengl.GL11.glRotated;
 import static org.lwjgl.opengl.GL11.glScaled;
 import static org.lwjgl.opengl.GL11.glTranslated;
 
-public class ItemModelStandard extends ItemModel{
+public class StandardItemModel extends ItemModel{
     final Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
     public static final IconCoordinate ITEM_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:item/texture_missing");
     public static final IconCoordinate ITEM_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:item/texture_unassigned");
@@ -48,7 +49,7 @@ public class ItemModelStandard extends ItemModel{
     protected boolean pointInfrontOfPlayer = false;
     protected boolean itemfullBright = false;
 
-    public ItemModelStandard(Item item, String namespace) {
+    public StandardItemModel(Item item, String namespace) {
         super(item);
         if (namespace != null){
             icon = TextureRegistry.getTexture(namespace + ":item/" + item.getKey().substring("item.".length()).replace(".", "_"));
@@ -56,7 +57,7 @@ public class ItemModelStandard extends ItemModel{
     }
 
     @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
+    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
         float brightness = 1.0f;
         if(mc.fullbright || itemfullBright || LightmapHelper.isLightmapEnabled()) {
         	if(LightmapHelper.isLightmapEnabled()) {
@@ -78,7 +79,7 @@ public class ItemModelStandard extends ItemModel{
         GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
         GL11.glTranslatef(0.7F * distanceScale, -0.65F * distanceScale - (1.0F - renderer.getEquippedProgress(partialTick)) * 0.6F, -0.9F * distanceScale); // Positions hand in correct place on right side of screen
         GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F); // 45 degrees tilt, makes it face more towards the camera
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
         float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
         GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
@@ -140,7 +141,7 @@ public class ItemModelStandard extends ItemModel{
         glEnable(GL_CULL_FACE);
         IconCoordinate textureIndex = getIcon(mc.thePlayer, itemStack);
         GL11.glDisable(GL_LIGHTING);
-        textureIndex.parentAtlas.bindTexture();
+        textureIndex.parentAtlas.bind();
         if (useColor) {
             final int color = getColor(itemStack);
             final float r = (color >> 16 & 0xff) / 255F;
@@ -199,7 +200,7 @@ public class ItemModelStandard extends ItemModel{
         EntityRenderDispatcher renderDispatcher = EntityRenderDispatcher.instance;
         GL11.glScalef(0.5F, 0.5F, 0.5F);
         final IconCoordinate tex = getIcon(entity, itemstack);
-        tex.parentAtlas.bindTexture();
+        tex.parentAtlas.bind();
         if (useColor) {
             final int color = getColor(itemstack);
             final float r = (color >> 16 & 0xff) / 255F;
@@ -256,7 +257,7 @@ public class ItemModelStandard extends ItemModel{
         }
 
         IconCoordinate tex = getIcon(entity, itemStack);
-        tex.parentAtlas.bindTexture();
+        tex.parentAtlas.bind();
         int tileWidth = tex.width;
 
         float uMin = (float) tex.getIconUMin();
@@ -269,7 +270,7 @@ public class ItemModelStandard extends ItemModel{
 
         final float foon = (0.5f / 512);
         final float goon = 0.0625f * (16.0f / tileWidth);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final float thickness = 0.0625f;
         final float pixelWidth = 1f/tileWidth;
 
@@ -355,7 +356,7 @@ public class ItemModelStandard extends ItemModel{
         }
         tessellator.draw();
 
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glDisable(GL_BLEND);
     }
 
@@ -458,22 +459,22 @@ public class ItemModelStandard extends ItemModel{
 
     }
 
-    public ItemModelStandard setFull3D()
+    public StandardItemModel setFull3D()
     {
         bFull3D = true;
         return this;
     }
-    public ItemModelStandard setRotateWhenRendering()
+    public StandardItemModel setRotateWhenRendering()
     {
         rotateWhenRendering = true;
         return this;
     }
-    public ItemModelStandard setPointInfrontOfPlayer()
+    public StandardItemModel setPointInfrontOfPlayer()
     {
         pointInfrontOfPlayer = true;
         return this;
     }
-    public ItemModelStandard setFullBright()
+    public StandardItemModel setFullBright()
     {
         itemfullBright = true;
         return this;
diff --git a/src/main/java/net/minecraft/client/render/model/ModelFlagBase.java b/src/main/java/net/minecraft/client/render/model/BaseFlagModel.java
similarity index 81%
rename from src/main/java/net/minecraft/client/render/model/ModelFlagBase.java
rename to src/main/java/net/minecraft/client/render/model/BaseFlagModel.java
index 7b5a5d2d4..61108cea2 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelFlagBase.java
+++ b/src/main/java/net/minecraft/client/render/model/BaseFlagModel.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.model;
 
-public class ModelFlagBase {
+public class BaseFlagModel {
     public Cube flagBase;
 
-    public ModelFlagBase()
+    public BaseFlagModel()
     {
         flagBase = new Cube(0, 0);
         flagBase.addBox(-2F, 10F, -2F, 4, 2, 4, 0.0F);
diff --git a/src/main/java/net/minecraft/client/render/model/BaseModel.java b/src/main/java/net/minecraft/client/render/model/BaseModel.java
new file mode 100644
index 000000000..fa5a0c5a3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/BaseModel.java
@@ -0,0 +1,31 @@
+package net.minecraft.client.render.model;
+
+import net.minecraft.core.entity.Mob;
+
+public abstract class BaseModel
+{
+
+    public BaseModel()
+    {
+        isRiding = false;
+    }
+
+    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+    }
+
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+    }
+
+    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
+    {
+    }
+
+    public void onUnload(){
+
+    }
+
+    public float onGround;
+    public boolean isRiding;
+}
diff --git a/src/main/java/net/minecraft/client/render/model/BipedModel.java b/src/main/java/net/minecraft/client/render/model/BipedModel.java
new file mode 100644
index 000000000..94b0b9fec
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/BipedModel.java
@@ -0,0 +1,170 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BaseModel, ModelRenderer, MathHelper
+
+import net.minecraft.core.util.helper.MathHelper;
+
+public class BipedModel extends BaseModel
+{
+    public Cube head;
+    public Cube hair;
+    public Cube body;
+    public Cube arm0;
+    public Cube arm1;
+    public Cube leg0;
+    public Cube leg1;
+    public Cube ear;
+    public Cube cloak;
+    public boolean holdingLeftHand;
+    public boolean holdingRightHand;
+    public boolean sneaking;
+
+
+    public BipedModel()
+    {
+        this(0.0F);
+    }
+
+    public BipedModel(float expansion)
+    {
+        this(expansion, 0.0F);
+    }
+
+    public BipedModel(float expansion, float yRotOffset)
+    {
+        holdingLeftHand = false;
+        holdingRightHand = false;
+        sneaking = false;
+        cloak = new Cube(0, 0);
+        cloak.addBox(-5F, 0.0F, -1F, 10, 16, 1, expansion);
+        ear = new Cube(24, 0);
+        ear.addBox(-3F, -6F, -1F, 6, 6, 1, expansion);
+        head = new Cube(0, 0);
+        head.addBox(-4F, -8F, -4F, 8, 8, 8, expansion);
+        head.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
+        hair = new Cube(32, 0);
+        hair.addBox(-4F, -8F, -4F, 8, 8, 8, expansion + 0.5F);
+        hair.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
+        body = new Cube(16, 16);
+        body.addBox(-4F, 0.0F, -2F, 8, 12, 4, expansion);
+        body.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
+        arm0 = new Cube(40, 16);
+        arm0.addBox(-3F, -2F, -2F, 4, 12, 4, expansion);
+        arm0.setRotationPoint(-5F, 2.0F + yRotOffset, 0.0F);
+        arm1 = new Cube(40, 16);
+        arm1.mirror = true;
+        arm1.addBox(-1F, -2F, -2F, 4, 12, 4, expansion);
+        arm1.setRotationPoint(5F, 2.0F + yRotOffset, 0.0F);
+        leg0 = new Cube(0, 16);
+        leg0.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion);
+        leg0.setRotationPoint(-2F, 12F + yRotOffset, 0.0F);
+        leg1 = new Cube(0, 16);
+        leg1.mirror = true;
+        leg1.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion);
+        leg1.setRotationPoint(2.0F, 12F + yRotOffset, 0.0F);
+    }
+
+    @Override
+    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        head.render(scale);
+        body.render(scale);
+        arm0.render(scale);
+        arm1.render(scale);
+        leg0.render(scale);
+        leg1.render(scale);
+        hair.render(scale);
+    }
+
+    @Override
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        head.yRot = headYaw / 57.29578F;
+        head.xRot = headPitch / 57.29578F;
+        hair.yRot = head.yRot;
+        hair.xRot = head.xRot;
+        arm0.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 2.0F * limbYaw * 0.5F;
+        arm1.xRot = MathHelper.cos(limbSwing * 0.6662F) * 2.0F * limbYaw * 0.5F;
+        arm0.zRot = 0.0F;
+        arm1.zRot = 0.0F;
+        leg0.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg0.yRot = 0.0F;
+        leg1.yRot = 0.0F;
+        if(isRiding)
+        {
+            arm0.xRot += -0.6283185F;
+            arm1.xRot += -0.6283185F;
+            leg0.xRot = -1.256637F;
+            leg1.xRot = -1.256637F;
+            leg0.yRot = 0.3141593F;
+            leg1.yRot = -0.3141593F;
+        }
+        if(holdingLeftHand)
+        {
+            arm1.xRot = arm1.xRot * 0.5F - 0.3141593F;
+        }
+        if(holdingRightHand)
+        {
+            arm0.xRot = arm0.xRot * 0.5F - 0.3141593F;
+        }
+        arm0.yRot = 0.0F;
+        arm1.yRot = 0.0F;
+        if(onGround > -9990F)
+        {
+            float f6 = onGround;
+            body.yRot = MathHelper.sin(MathHelper.sqrt_float(f6) * MathHelper.PI * 2.0F) * 0.2F;
+            arm0.z = MathHelper.sin(body.yRot) * 5F;
+            arm0.x = -MathHelper.cos(body.yRot) * 5F;
+            arm1.z = -MathHelper.sin(body.yRot) * 5F;
+            arm1.x = MathHelper.cos(body.yRot) * 5F;
+            arm0.yRot += body.yRot;
+            arm1.yRot += body.yRot;
+            arm1.xRot += body.yRot;
+            f6 = 1.0F - onGround;
+            f6 *= f6;
+            f6 *= f6;
+            f6 = 1.0F - f6;
+            float f7 = MathHelper.sin(f6 * MathHelper.PI);
+            float f8 = MathHelper.sin(onGround * MathHelper.PI) * -(head.xRot - 0.7F) * 0.75F;
+            arm0.xRot -= (double)f7 * 1.2D + (double)f8;
+            arm0.yRot += body.yRot * 2.0F;
+            arm0.zRot = MathHelper.sin(onGround * MathHelper.PI) * -0.4F;
+        }
+        if(sneaking)
+        {
+            body.xRot = 0.5F;
+            leg0.xRot -= 0.0F;
+            leg1.xRot -= 0.0F;
+            arm0.xRot += 0.4F;
+            arm1.xRot += 0.4F;
+            leg0.z = 4F;
+            leg1.z = 4F;
+            leg0.y = 9F;
+            leg1.y = 9F;
+            head.y = 1.0F;
+            hair.y = 1.0F;
+        } else
+        {
+            body.xRot = 0.0F;
+            leg0.z = 0.0F;
+            leg1.z = 0.0F;
+            leg0.y = 12F;
+            leg1.y = 12F;
+            head.y = 0.0F;
+            hair.y = 0.0F;
+        }
+        arm0.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        arm1.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        arm0.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        arm1.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+    }
+
+    public void renderCloak(float scale)
+    {
+        cloak.render(scale);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/model/BoatModel.java b/src/main/java/net/minecraft/client/render/model/BoatModel.java
new file mode 100644
index 000000000..a2f287f7f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/BoatModel.java
@@ -0,0 +1,51 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BaseModel, ModelRenderer
+
+import net.minecraft.core.util.helper.MathHelper;
+
+public class BoatModel extends BaseModel
+{
+    public Cube[] boatSides;
+    public BoatModel()
+    {
+        boatSides = new Cube[5];
+        boatSides[0] = new Cube(0, 8);
+        boatSides[1] = new Cube(0, 0);
+        boatSides[2] = new Cube(0, 0);
+        boatSides[3] = new Cube(0, 0);
+        boatSides[4] = new Cube(0, 0);
+        byte w = 24;
+        byte d = 6;
+        byte h = 20;
+        byte yOff = 4;
+        boatSides[0].addBox(-w / 2, -h / 2 + 2, -3F, w, h - 4, 4, 0.0F);
+        boatSides[0].setRotationPoint(0.0F, 0 + yOff, 0.0F);
+        boatSides[1].addBox(-w / 2 + 2, -d - 1, -1F, w - 4, d, 2, 0.0F);
+        boatSides[1].setRotationPoint(-w / 2 + 1, 0 + yOff, 0.0F);
+        boatSides[2].addBox(-w / 2 + 2, -d - 1, -1F, w - 4, d, 2, 0.0F);
+        boatSides[2].setRotationPoint(w / 2 - 1, 0 + yOff, 0.0F);
+        boatSides[3].addBox(-w / 2 + 2, -d - 1, -1F, w - 4, d, 2, 0.0F);
+        boatSides[3].setRotationPoint(0.0F, 0 + yOff, -h / 2 + 1);
+        boatSides[4].addBox(-w / 2 + 2, -d - 1, -1F, w - 4, d, 2, 0.0F);
+        boatSides[4].setRotationPoint(0.0F, 0 + yOff, h / 2 - 1);
+        boatSides[0].xRot = MathHelper.PI / 2F;
+        boatSides[1].yRot = MathHelper.PI * 1.5F;
+        boatSides[2].yRot = MathHelper.PI / 2F;
+        boatSides[3].yRot = MathHelper.PI;
+    }
+
+    @Override
+    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        for(int i = 0; i < 5; i++)
+        {
+            boatSides[i].render(scale);
+        }
+
+    }
+
+
+}
diff --git a/src/main/java/net/minecraft/client/render/model/ModelCannonball.java b/src/main/java/net/minecraft/client/render/model/CannonballModel.java
similarity index 65%
rename from src/main/java/net/minecraft/client/render/model/ModelCannonball.java
rename to src/main/java/net/minecraft/client/render/model/CannonballModel.java
index 2d2c54c90..9e2da7dce 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelCannonball.java
+++ b/src/main/java/net/minecraft/client/render/model/CannonballModel.java
@@ -2,12 +2,12 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer
+//            BaseModel, ModelRenderer
 
-public class ModelCannonball extends ModelBase
+public class CannonballModel extends BaseModel
 {
 
-    public ModelCannonball()
+    public CannonballModel()
     {
         ball = new Cube(0, 0);
         ball.addBox(0F, 0F, 0F, 8, 8, 8);
@@ -22,7 +22,7 @@ public class ModelCannonball extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
     }
 
diff --git a/src/main/java/net/minecraft/client/render/model/ModelChicken.java b/src/main/java/net/minecraft/client/render/model/ChickenModel.java
similarity index 50%
rename from src/main/java/net/minecraft/client/render/model/ModelChicken.java
rename to src/main/java/net/minecraft/client/render/model/ChickenModel.java
index 508702eea..58046c1b0 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelChicken.java
+++ b/src/main/java/net/minecraft/client/render/model/ChickenModel.java
@@ -2,46 +2,55 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer, MathHelper
+//            BaseModel, ModelRenderer, MathHelper
 
 import net.minecraft.core.util.helper.MathHelper;
 
-public class ModelChicken extends ModelBase
+public class ChickenModel extends BaseModel
 {
+    public Cube head;
+    public Cube body;
+    public Cube rightLeg;
+    public Cube leftLeg;
+    public Cube rightWing;
+    public Cube leftWing;
+    public Cube bill;
+    public Cube chin;
+
 
-    public ModelChicken()
+    public ChickenModel()
     {
-        byte byte0 = 16;
+        byte yOff = 16;
         head = new Cube(0, 0);
         head.addBox(-2F, -6F, -2F, 4, 6, 3, 0.0F);
-        head.setRotationPoint(0.0F, -1 + byte0, -4F);
+        head.setRotationPoint(0.0F, -1 + yOff, -4F);
         bill = new Cube(14, 0);
         bill.addBox(-2F, -4F, -4F, 4, 2, 2, 0.0F);
-        bill.setRotationPoint(0.0F, -1 + byte0, -4F);
+        bill.setRotationPoint(0.0F, -1 + yOff, -4F);
         chin = new Cube(14, 4);
         chin.addBox(-1F, -2F, -3F, 2, 2, 2, 0.0F);
-        chin.setRotationPoint(0.0F, -1 + byte0, -4F);
+        chin.setRotationPoint(0.0F, -1 + yOff, -4F);
         body = new Cube(0, 9);
         body.addBox(-3F, -4F, -3F, 6, 8, 6, 0.0F);
-        body.setRotationPoint(0.0F, 0 + byte0, 0.0F);
+        body.setRotationPoint(0.0F, 0 + yOff, 0.0F);
         rightLeg = new Cube(26, 0);
         rightLeg.addBox(-1F, 0.0F, -3F, 3, 5, 3);
-        rightLeg.setRotationPoint(-2F, 3 + byte0, 1.0F);
+        rightLeg.setRotationPoint(-2F, 3 + yOff, 1.0F);
         leftLeg = new Cube(26, 0);
         leftLeg.addBox(-1F, 0.0F, -3F, 3, 5, 3);
-        leftLeg.setRotationPoint(1.0F, 3 + byte0, 1.0F);
+        leftLeg.setRotationPoint(1.0F, 3 + yOff, 1.0F);
         rightWing = new Cube(24, 13);
         rightWing.addBox(0.0F, 0.0F, -3F, 1, 4, 6);
-        rightWing.setRotationPoint(-4F, -3 + byte0, 0.0F);
+        rightWing.setRotationPoint(-4F, -3 + yOff, 0.0F);
         leftWing = new Cube(24, 13);
         leftWing.addBox(-1F, 0.0F, -3F, 1, 4, 6);
-        leftWing.setRotationPoint(4F, -3 + byte0, 0.0F);
+        leftWing.setRotationPoint(4F, -3 + yOff, 0.0F);
     }
 
     @Override
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         head.render(scale);
         bill.render(scale);
         chin.render(scale);
@@ -53,27 +62,18 @@ public class ModelChicken extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        head.rotateAngleX = headPitch / 57.29578F;
-        head.rotateAngleY = headYaw / 57.29578F;
-        bill.rotateAngleX = head.rotateAngleX;
-        bill.rotateAngleY = head.rotateAngleY;
-        chin.rotateAngleX = head.rotateAngleX;
-        chin.rotateAngleY = head.rotateAngleY;
-        body.rotateAngleX = 1.570796F;
-        rightLeg.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
-        leftLeg.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F + 3.141593F) * 1.4F * limbYaw;
-        rightWing.rotateAngleZ = limbPitch;
-        leftWing.rotateAngleZ = -limbPitch;
+        head.xRot = headPitch / 57.29578F;
+        head.yRot = headYaw / 57.29578F;
+        bill.xRot = head.xRot;
+        bill.yRot = head.yRot;
+        chin.xRot = head.xRot;
+        chin.yRot = head.yRot;
+        body.xRot = MathHelper.PI / 2F;
+        rightLeg.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leftLeg.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        rightWing.zRot = limbPitch;
+        leftWing.zRot = -limbPitch;
     }
-
-    public Cube head;
-    public Cube body;
-    public Cube rightLeg;
-    public Cube leftLeg;
-    public Cube rightWing;
-    public Cube leftWing;
-    public Cube bill;
-    public Cube chin;
 }
